angular.module('starter.controllers', [])

.controller('InputCtrl', function($scope,$state,commonService,$cordovaInAppBrowser,$ionicModal,$cordovaToast,$localstorage) {
        $scope.openLink=function(){
          $cordovaInAppBrowser
            .open("http://vijayramanan.com/", '_system')
            .then(function(event) {
              // success
            }, function(event) {
              // error
            });
        };
    $scope.thalessemia={};
    if($localstorage.checkItem("thalUser")){
      $scope.user=$localstorage.getObject("thalUser");
    }
    $scope.check = function(form) {
      if(!form.$valid) {
        $scope.alerts=[];
        $scope.alerts.push({
          type: 'danger',
          msg: 'Please fill all mandatory fields.'
        });
      }else{
        commonService.thalessemia=$scope.thalessemia;
        if(undefined == $scope.user){
          $ionicModal.fromTemplateUrl('templates/details.html', {
            scope: $scope
          }).then(function(modal) {
            $scope.detailData={};
            $scope.modal = modal;
            $scope.modal.show();

          });
        }else{
          $scope.addDetails();
        }
      }
    };
    $scope.doSubmit=function(form){
        $scope.alerts1=[];
        if(!form.$valid) {
          $scope.alerts1.push({
            type: 'danger',
            msg: 'Please fill all mandatory fields and submit again.'
          });
        }else{
          var User = Parse.Object.extend("UserDetails");
          var user = new User();
          user.set("name",$scope.detailData.name);
          user.set("phoneNumber",$scope.detailData.phone);
          user.set("email",$scope.detailData.email);
          user.save(null, {
            success: function(user) {
              $localstorage.setObject("thalUser",user);
              console.log(user);
              $scope.user=user;
              $scope.addDetails();
            },
            error: function(user, error) {
              console.log(error);
              $cordovaToast.showShortBottom('There was an error while saving..');
              $scope.addDetails();

            }
          });
      }
    }
    $scope.addDetails=function(){
      var Thalassaemia = Parse.Object.extend("Thalassaemia");
      var thalassaemia = new Thalassaemia();
      thalassaemia.set("Hemoglobin",$scope.thalessemia.hemoglobin);
      thalassaemia.set("RBCCount",$scope.thalessemia.rbc);
      thalassaemia.set("MCV",$scope.thalessemia.mcv);
      thalassaemia.set("SrFerritin",$scope.thalessemia.ferritin);
      thalassaemia.set("userId",{
        __type: "Pointer",
        className: "UserDetails",
        objectId:$scope.user.objectId
      });
      thalassaemia.save(null, {
        success: function(data) {
          $state.go("tab.result");
          if(undefined != $scope.modal){
            $scope.modal.hide();
          }
        },
        error: function(data, error) {
          $cordovaToast.showShortBottom('There was an error while saving..');
          $state.go("tab.result");
          if(undefined != $scope.modal){
            $scope.modal.hide();
          }
        }
      });
    }
  })

.controller('ResultCtrl', function($scope, $state,commonService,$cordovaInAppBrowser,$cordovaSocialSharing) {
    $scope.goBack=function(){
      $state.go("tab.home");
    };
    $scope.openLink=function(){
      $scope.openLink=function(){
        $cordovaInAppBrowser
          .open("http://vijayramanan.com/", '_system')
          .then(function(event) {
            // success
          }, function(event) {
            // error
          });
      };
    };
    $scope.openMVRLink=function(){
        $cordovaInAppBrowser
          .open("http://mvrfoundation.com/", '_system')
          .then(function(event) {
            // success
          }, function(event) {
            console.log("social error:"+event);
          });
    };
    $scope.share= function(){
      $cordovaSocialSharing.share("I have tried this app and loved it!", "Thalasseamia Diagnosis App", "www/img/yashoda_logo.png", "https://play.google.com/store/search?q=padmaraj%20madatha&hl=en");


    }

    if(commonService.thalessemia ==undefined){
      $state.go("tab.home");
    }else{
      $scope.condition1= (commonService.thalessemia.hemoglobin*3)>commonService.thalessemia.rbc?true:false;
      $scope.condition2= (commonService.thalessemia.mcv/commonService.thalessemia.rbc)<13?true:false;
      $scope.condition3= (commonService.thalessemia.mcv)<=78?true:false;
      $scope.condition4= (commonService.thalessemia.ferritin!=undefined && commonService.thalessemia.ferritin<100)?true:false;
      $scope.result={};
      if($scope.condition1 || $scope.condition2 || $scope.condition3){
        $scope.result.message="Thalessimia Minor";
        $scope.result.class="orange";
      }else{
        $scope.result.message="No Thalessimia detected";
        $scope.result.class="green";
      }
      if($scope.condition1 && $scope.condition2){
        $scope.result.text="Consider getting family tested for Thalassemia. If both spouse are Thalassemia Minor then consider ANTENATAL diagnosis at 8-10 weeks.";
      }else if($scope.condition1){
        $scope.result.text="Suspicious of Thalassemia Trait. Please do mutation analysis.";
      }else if($scope.condition4){
        $scope.result.text="Please do HbA2 quantification after correcting iron deficiency.";
      }
    }
});
